const { WebSocket } = require("ws");

const wsAddress =
  "ws://localhost:6060/v0/channels?apikey=AQEAAAABAAD_rAp4DJh05a1HAwFT3A6K";

function print(msg, txt) {
  console.log(`${new Date()} ${txt}: ${msg}`);
}

function send_message(ws, msg) {
  print(msg, "out");
  ws.send(msg);
}

const timeout = (ms) => new Promise((res) => setTimeout(res, ms));

const ws1 = new WebSocket(wsAddress);
const ws2 = new WebSocket(wsAddress);

function infoMissing1() {
  ws1.on("open", () => {
    console.log("Connected to server1");
    send_message(
      ws1,
      '{ "hi": { "id": "id-hi-1", "ver": "0.19.3", "ua": "CREATEGROUPS" }}'
    );

    ws1.on("message", async (ws1Message) => {
      const parsed = JSON.parse(ws1Message);
      print(JSON.stringify(parsed), "in");

      if (parsed.data) {
        send_message(
          ws1,
          `{"note":{"id":"id-note-1", "topic":"${parsed.data.from}", "seq":${parsed.data.seq}, "what":"recv"}}`
        );
        send_message(
          ws1,
          `{"note":{"id":"id-note-1", "topic":"${parsed.data.from}", "seq":${parsed.data.seq}, "what":"read"}}`
        );
      }

      if (parsed.ctrl) {
        if (parsed.ctrl.code > 299 || parsed.ctrl.code < 200) {
          //   console.log("Error from server", parsed.ctrl);
        }

        switch (parsed.ctrl.id) {
          case "id-hi-1": {
            send_message(
              ws1,
              `{"login":{"id":"id-login-1","scheme":"token","secret":"IoXH4yjUJMgOb4pkFAABAAEArczoL/e//2LZb491ZheULZBT/rFdyB/vTGE4sSqPsNo="}}`
            );
            break;
          }
          case "id-login-1": {
            send_message(ws1, `{"sub":{"id":"id-sub-me-1", "topic":"me"}}`);
            break;
          }
          case "id-sub-me-1": {
            await timeout(1000);
            send_message(
              ws1,
              `{"sub":{"id":"id-sub-t1","topic":"usrsvxfCch7U5k"}}`
            );
            break;
          }
          case "id-sub-t1": {
            await timeout(5000);
            send_message(
              ws1,
              `{"pub":{"id":"id-pub-t1","topic":"usrsvxfCch7U5k","content":"Hi from 1", "noecho":true}}`
            );
            break;
          }
          default:
            break;
        }
      }
    });
  });

  ws1.on("error", (err) => {
    console.log(err);
  });

  ws1.on("close", () => {
    console.log("Disconnected from server");
  });
}

function infoMissing2() {
  ws2.on("open", () => {
    console.log("Connected to server2");
    send_message(
      ws2,
      '{ "hi": { "id": "id-hi-2", "ver": "0.19.3", "ua": "CREATEGROUPS" }}'
    );

    ws2.on("message", async (ws2Message) => {
      const parsed = JSON.parse(ws2Message);
      print(JSON.stringify(parsed), "in");

      if (parsed.data) {
        send_message(
          ws2,
          `{"note":{"id":"id-note-2", "topic":"${parsed.data.from}", "seq":${parsed.data.seq}, "what":"recv"}}`
        );
        send_message(
          ws2,
          `{"note":{"id":"id-note-2", "topic":"${parsed.data.from}", "seq":${parsed.data.seq}, "what":"read"}}`
        );
      }

      if (parsed.ctrl) {
        if (parsed.ctrl.code > 299 || parsed.ctrl.code < 200) {
          //   console.log("Error from server", parsed.ctrl);
        }

        switch (parsed.ctrl.id) {
          case "id-hi-2": {
            send_message(
              ws2,
              `{"login":{"id":"id-login-2","scheme":"token","secret":"svxfCch7U5kLb4pkFAABAAEAAniGIM0DURiwQzCjXAYixUGqWd5Q7AEdPjZyWRmaAcE="}}`
            );
            break;
          }
          case "id-login-2": {
            send_message(ws2, `{"sub":{"id":"id-sub-me-2", "topic":"me"}}`);
            break;
          }
          case "id-sub-me-2": {
            await timeout(1250);
            send_message(
              ws2,
              `{"sub":{"id":"id-sub-t2","topic":"usrIoXH4yjUJMg"}}`
            );
            break;
          }
          case "id-sub-t2": {
            await timeout(4750);
            send_message(
              ws2,
              `{"pub":{"id":"id-pub-t2","topic":"usrIoXH4yjUJMg","content":"Hi from 2", "noecho":true}}`
            );
            break;
          }
          default:
            break;
        }
      }
    });
  });

  ws2.on("error", (err) => {
    console.log(err);
  });

  ws2.on("close", () => {
    console.log("Disconnected from server");
  });
}

infoMissing1();

infoMissing2();
